ALTER TABLE `Users`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);;

ALTER TABLE `Users`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);;

DROP TRIGGER IF EXISTS `TR_UsersUpdate`;;

CREATE TRIGGER `TR_UsersUpdate`
    AFTER UPDATE
    ON `Users`
    FOR EACH ROW
BEGIN
    INSERT INTO `UsersHistory` (`Id`, `DiscordId`, `XP`, `ReactionCount`, `MessageCount`, `ServerId`,
                                `DateFrom`, `DateTo`)
    VALUES (OLD.UserId, OLD.DiscordId, OLD.XP, OLD.ReactionCount, OLD.MessageCount, OLD.ServerId,
            OLD.LastModifiedAt, CURRENT_TIMESTAMP(6));
END;;

DROP TRIGGER IF EXISTS `TR_UsersDelete`;;

CREATE TRIGGER `TR_UsersDelete`
    AFTER DELETE
    ON `Users`
    FOR EACH ROW
BEGIN
    INSERT INTO `UsersHistory` (`Id`, `DiscordId`, `XP`, `ReactionCount`, `MessageCount`, `ServerId`,
                                `Deleted`, `DateFrom`, `DateTo`)
    VALUES (OLD.UserId, OLD.DiscordId, OLD.XP, OLD.ReactionCount, OLD.MessageCount, OLD.ServerId, TRUE,
            OLD.LastModifiedAt, CURRENT_TIMESTAMP(6));
END;;

